#ifndef SANGURU_BUTTON_H_ 
#define SANGURU_BUTTON_H_
#include "Arduino.h"

#define ON_DEBOUNCE 1
#define OVER_DEBOUNCE 0
#define DEBOUNCE_DURATION_MIL 30
#define LONG_PRESS_DURATION_MIL 1000
#define REPEAT_DURATION_MIL 350 

#define BUTTON_NONE 0
#define ON_RELEASED 1
#define ON_PRESSED 2
#define RELEASED 4
#define PRESSED 8
#define REPEAT 16
#define LONG_PRESSED 32

class SanguruButton {
  	public:

  	// constructor 에는 void 조차도 없다.
  	SanguruButton(byte buttonPin);

  	// ISR에 이 메쏘드를 넣어야 한다.
  	void update();

  	// 버튼 상태를 읽는다
  	byte getButton();

  	void setLongPress(bool trueOrFalse);
  	void setRepeat(bool trueOrFalse);
    /*
  	const byte buttonNone = 0; 
	const byte onReleased = 1;
	const byte onPressed = 2;
	const byte released = 4;
	const byte pressed = 8;
	const byte repeat = 16;
	const byte longPressed = 32;
    */
    // 아래 3가지 mil은 값을 바꿔도 된다  
  	unsigned long debounceDurationMil = DEBOUNCE_DURATION_MIL;
	unsigned long longPressDurationMil = LONG_PRESS_DURATION_MIL;
	unsigned long repeatDurationMil = REPEAT_DURATION_MIL;
	
	private:
	byte buttonPin;

	//volatile unsigned long thisMil;
	volatile byte debounceMode = OVER_DEBOUNCE; 
	
	volatile byte buttonRead = HIGH;
	volatile byte prevButtonRead = HIGH;
	volatile unsigned long buttonPressMil = 0;
	volatile unsigned long debounceEndMil;
	volatile bool isButtonChanged = false;

	// isSetLongPress와 isSetRepeat는 하나가 true로 되면 나머지는 false로 된다 
	volatile bool isSetLongPress = false;
	volatile bool isSetRepeat = false;

	volatile byte buttonOperation = BUTTON_NONE;
	volatile byte prevButtonOperation = BUTTON_NONE; 
	volatile bool isLongPressOn = false;

};
//↑ class 뒤에는 ;가 있어야 한다.
#endif